# Interconnects ## List existing interconnects `client.NetworkInterconnects.Interconnects.List(ctx, params) (*InterconnectListResponse, error)` **get** `/accounts/{account_id}/cni/interconnects` List existing interconnects ### Parameters - `params InterconnectListParams` - `AccountID param.Field[string]` Path param: Customer account tag - `Cursor param.Field[int64]` Query param - `Limit param.Field[int64]` Query param - `Site param.Field[string]` Query param: If specified, only show interconnects located at the given site - `Type param.Field[string]` Query param: If specified, only show interconnects of the given type ### Returns - `type InterconnectListResponse struct{…}` - `Items []InterconnectListResponseItem` - `type InterconnectListResponseItemsNscInterconnectPhysicalBody struct{…}` - `Account string` - `Facility InterconnectListResponseItemsNscInterconnectPhysicalBodyFacility` - `Address []string` - `Name string` - `Name string` - `Site string` A Cloudflare site name. - `SlotID string` - `Speed string` - `Type string` - `Owner string` - `type InterconnectListResponseItemsNscInterconnectGcpPartnerBody struct{…}` - `Account string` - `Name string` - `Region string` - `Type string` - `Owner string` - `Speed InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed` Bandwidth structure as visible through the customer-facing API. - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed50M InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "50M"` - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed100M InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "100M"` - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed200M InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "200M"` - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed300M InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "300M"` - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed400M InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "400M"` - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed500M InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "500M"` - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed1G InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "1G"` - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed2G InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "2G"` - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed5G InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "5G"` - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed10G InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "10G"` - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed20G InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "20G"` - `const InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed50G InterconnectListResponseItemsNscInterconnectGcpPartnerBodySpeed = "50G"` - `Next int64` ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/network_interconnects" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) interconnects, err := client.NetworkInterconnects.Interconnects.List(context.TODO(), network_interconnects.InterconnectListParams{ AccountID: cloudflare.F("account_id"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", interconnects.Items) } ``` #### Response ```json { "items": [ { "account": "account", "facility": { "address": [ "string" ], "name": "name" }, "name": "name", "site": "site", "slot_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e", "speed": "speed", "type": "type", "owner": "owner" } ], "next": 0 } ``` ## Get information about an interconnect object `client.NetworkInterconnects.Interconnects.Get(ctx, icon, query) (*InterconnectGetResponse, error)` **get** `/accounts/{account_id}/cni/interconnects/{icon}` Get information about an interconnect object ### Parameters - `icon string` - `query InterconnectGetParams` - `AccountID param.Field[string]` Customer account tag ### Returns - `type InterconnectGetResponse interface{…}` - `type InterconnectGetResponseNscInterconnectPhysicalBody struct{…}` - `Account string` - `Facility InterconnectGetResponseNscInterconnectPhysicalBodyFacility` - `Address []string` - `Name string` - `Name string` - `Site string` A Cloudflare site name. - `SlotID string` - `Speed string` - `Type string` - `Owner string` - `type InterconnectGetResponseNscInterconnectGcpPartnerBody struct{…}` - `Account string` - `Name string` - `Region string` - `Type string` - `Owner string` - `Speed InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed` Bandwidth structure as visible through the customer-facing API. - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed50M InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "50M"` - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed100M InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "100M"` - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed200M InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "200M"` - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed300M InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "300M"` - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed400M InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "400M"` - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed500M InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "500M"` - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed1G InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "1G"` - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed2G InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "2G"` - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed5G InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "5G"` - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed10G InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "10G"` - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed20G InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "20G"` - `const InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed50G InterconnectGetResponseNscInterconnectGcpPartnerBodySpeed = "50G"` ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/network_interconnects" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) interconnect, err := client.NetworkInterconnects.Interconnects.Get( context.TODO(), "icon", network_interconnects.InterconnectGetParams{ AccountID: cloudflare.F("account_id"), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", interconnect) } ``` #### Response ```json { "account": "account", "facility": { "address": [ "string" ], "name": "name" }, "name": "name", "site": "site", "slot_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e", "speed": "speed", "type": "type", "owner": "owner" } ``` ## Create a new interconnect `client.NetworkInterconnects.Interconnects.New(ctx, params) (*InterconnectNewResponse, error)` **post** `/accounts/{account_id}/cni/interconnects` Create a new interconnect ### Parameters - `params InterconnectNewParams` - `AccountID param.Field[string]` Path param: Customer account tag - `Account param.Field[string]` Body param - `SlotID param.Field[string]` Body param - `Type param.Field[string]` Body param - `Speed param.Field[string]` Body param ### Returns - `type InterconnectNewResponse interface{…}` - `type InterconnectNewResponseNscInterconnectPhysicalBody struct{…}` - `Account string` - `Facility InterconnectNewResponseNscInterconnectPhysicalBodyFacility` - `Address []string` - `Name string` - `Name string` - `Site string` A Cloudflare site name. - `SlotID string` - `Speed string` - `Type string` - `Owner string` - `type InterconnectNewResponseNscInterconnectGcpPartnerBody struct{…}` - `Account string` - `Name string` - `Region string` - `Type string` - `Owner string` - `Speed InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed` Bandwidth structure as visible through the customer-facing API. - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed50M InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "50M"` - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed100M InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "100M"` - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed200M InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "200M"` - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed300M InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "300M"` - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed400M InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "400M"` - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed500M InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "500M"` - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed1G InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "1G"` - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed2G InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "2G"` - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed5G InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "5G"` - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed10G InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "10G"` - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed20G InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "20G"` - `const InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed50G InterconnectNewResponseNscInterconnectGcpPartnerBodySpeed = "50G"` ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/network_interconnects" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) interconnect, err := client.NetworkInterconnects.Interconnects.New(context.TODO(), network_interconnects.InterconnectNewParams{ AccountID: cloudflare.F("account_id"), Body: network_interconnects.InterconnectNewParamsBodyNscInterconnectCreatePhysicalBody{ Account: cloudflare.F("account"), SlotID: cloudflare.F("182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"), Type: cloudflare.F("type"), }, }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", interconnect) } ``` #### Response ```json { "account": "account", "facility": { "address": [ "string" ], "name": "name" }, "name": "name", "site": "site", "slot_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e", "speed": "speed", "type": "type", "owner": "owner" } ``` ## Delete an interconnect object `client.NetworkInterconnects.Interconnects.Delete(ctx, icon, body) error` **delete** `/accounts/{account_id}/cni/interconnects/{icon}` Delete an interconnect object ### Parameters - `icon string` - `body InterconnectDeleteParams` - `AccountID param.Field[string]` Customer account tag ### Example ```go package main import ( "context" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/network_interconnects" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) err := client.NetworkInterconnects.Interconnects.Delete( context.TODO(), "icon", network_interconnects.InterconnectDeleteParams{ AccountID: cloudflare.F("account_id"), }, ) if err != nil { panic(err.Error()) } } ``` ## Generate the Letter of Authorization (LOA) for a given interconnect `client.NetworkInterconnects.Interconnects.LOA(ctx, icon, query) error` **get** `/accounts/{account_id}/cni/interconnects/{icon}/loa` Generate the Letter of Authorization (LOA) for a given interconnect ### Parameters - `icon string` - `query InterconnectLOAParams` - `AccountID param.Field[string]` Customer account tag ### Example ```go package main import ( "context" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/network_interconnects" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) err := client.NetworkInterconnects.Interconnects.LOA( context.TODO(), "icon", network_interconnects.InterconnectLOAParams{ AccountID: cloudflare.F("account_id"), }, ) if err != nil { panic(err.Error()) } } ``` ## Get the current status of an interconnect object `client.NetworkInterconnects.Interconnects.Status(ctx, icon, query) (*InterconnectStatusResponse, error)` **get** `/accounts/{account_id}/cni/interconnects/{icon}/status` Get the current status of an interconnect object ### Parameters - `icon string` - `query InterconnectStatusParams` - `AccountID param.Field[string]` Customer account tag ### Returns - `type InterconnectStatusResponse interface{…}` - `type InterconnectStatusResponsePending struct{…}` - `State InterconnectStatusResponsePendingState` - `const InterconnectStatusResponsePendingStatePending InterconnectStatusResponsePendingState = "Pending"` - `type InterconnectStatusResponseDown struct{…}` - `State InterconnectStatusResponseDownState` - `const InterconnectStatusResponseDownStateDown InterconnectStatusResponseDownState = "Down"` - `Reason string` Diagnostic information, if available - `type InterconnectStatusResponseUnhealthy struct{…}` - `State InterconnectStatusResponseUnhealthyState` - `const InterconnectStatusResponseUnhealthyStateUnhealthy InterconnectStatusResponseUnhealthyState = "Unhealthy"` - `Reason string` Diagnostic information, if available - `type InterconnectStatusResponseHealthy struct{…}` - `State InterconnectStatusResponseHealthyState` - `const InterconnectStatusResponseHealthyStateHealthy InterconnectStatusResponseHealthyState = "Healthy"` ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/network_interconnects" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) response, err := client.NetworkInterconnects.Interconnects.Status( context.TODO(), "icon", network_interconnects.InterconnectStatusParams{ AccountID: cloudflare.F("account_id"), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", response) } ``` #### Response ```json { "state": "Pending" } ```